#pragma once

#include "CoreMinimal.h"
#include "SurvivorCosmeticHelperActor.h"
#include "DBDTunableRowHandle.h"
#include "GameplayTagContainer.h"
#include "ECamperDamageState.h"
#include "SurvivorClassCosmeticHelperActor.generated.h"

UCLASS(Blueprintable)
class ASurvivorClassCosmeticHelperActor : public ASurvivorCosmeticHelperActor
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FDBDTunableRowHandle _skillRadius;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FDBDTunableRowHandle _skillDuration;

	UPROPERTY(EditAnywhere)
	FGameplayTag _skillActivationBeginEventTag;

private:
	UFUNCTION(BlueprintCallable)
	void OnSurvivorDamageStateChanged(const ECamperDamageState oldState, const ECamperDamageState newState);

protected:
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_OnSurvivorUnhooked();

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_OnSurvivorDamageStateChanged(ECamperDamageState newState);

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_OnSurvivorCaged();

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_OnSkillActivationEnd();

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_OnSkillActivated();

public:
	ASurvivorClassCosmeticHelperActor();
};

FORCEINLINE uint32 GetTypeHash(const ASurvivorClassCosmeticHelperActor) { return 0; }
